#define SCPLX
#include "atlas_misc.h"
void ATL_cupMBmm6_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupMBmm12_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupMBmm18_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupMBmm24_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupMBmm30_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupMBmm36_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupMBmm42_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cgpMBmm_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupMBmm6_6_1_b1
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupMBmm12_6_1_b1
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupMBmm18_6_1_b1
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupMBmm24_6_1_b1
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupMBmm30_6_1_b1
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupMBmm36_6_1_b1
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupMBmm42_6_1_b1
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cgpMBmm_b1
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupMBmm6_6_1_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupMBmm12_6_1_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupMBmm18_6_1_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupMBmm24_6_1_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupMBmm30_6_1_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupMBmm36_6_1_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupMBmm42_6_1_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cgpMBmm_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);

static void ATL_CupMBmm6_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc)
{
   const float *rA = A + lda*M, *rB = B + ldb*N;
   ATL_cupMBmm6_6_1_b0(M, N, K, alpha, A, lda, B, ldb, ATL_rzero, C, ldc); 
   ATL_cupMBmm6_6_1_b0(M, N, K, alpha, A, lda, rB, ldb, beta, C+1, ldc); 
   ATL_cupMBmm6_6_1_bX(M, N, K, alpha, rA, lda, rB, ldb, ATL_rnone, C, ldc); 
   ATL_cupMBmm6_6_1_b1(M, N, K, alpha, rA, lda, B, ldb, ATL_rone, C+1, ldc); 
}
static void ATL_CupMBmm12_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc)
{
   const float *rA = A + lda*M, *rB = B + ldb*N;
   ATL_cupMBmm12_6_1_b0(M, N, K, alpha, A, lda, B, ldb, ATL_rzero, C, ldc); 
   ATL_cupMBmm12_6_1_b0(M, N, K, alpha, A, lda, rB, ldb, beta, C+1, ldc); 
   ATL_cupMBmm12_6_1_bX(M, N, K, alpha, rA, lda, rB, ldb, ATL_rnone, C, ldc); 
   ATL_cupMBmm12_6_1_b1(M, N, K, alpha, rA, lda, B, ldb, ATL_rone, C+1, ldc); 
}
static void ATL_CupMBmm18_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc)
{
   const float *rA = A + lda*M, *rB = B + ldb*N;
   ATL_cupMBmm18_6_1_b0(M, N, K, alpha, A, lda, B, ldb, ATL_rzero, C, ldc); 
   ATL_cupMBmm18_6_1_b0(M, N, K, alpha, A, lda, rB, ldb, beta, C+1, ldc); 
   ATL_cupMBmm18_6_1_bX(M, N, K, alpha, rA, lda, rB, ldb, ATL_rnone, C, ldc); 
   ATL_cupMBmm18_6_1_b1(M, N, K, alpha, rA, lda, B, ldb, ATL_rone, C+1, ldc); 
}
static void ATL_CupMBmm24_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc)
{
   const float *rA = A + lda*M, *rB = B + ldb*N;
   ATL_cupMBmm24_6_1_b0(M, N, K, alpha, A, lda, B, ldb, ATL_rzero, C, ldc); 
   ATL_cupMBmm24_6_1_b0(M, N, K, alpha, A, lda, rB, ldb, beta, C+1, ldc); 
   ATL_cupMBmm24_6_1_bX(M, N, K, alpha, rA, lda, rB, ldb, ATL_rnone, C, ldc); 
   ATL_cupMBmm24_6_1_b1(M, N, K, alpha, rA, lda, B, ldb, ATL_rone, C+1, ldc); 
}
static void ATL_CupMBmm30_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc)
{
   const float *rA = A + lda*M, *rB = B + ldb*N;
   ATL_cupMBmm30_6_1_b0(M, N, K, alpha, A, lda, B, ldb, ATL_rzero, C, ldc); 
   ATL_cupMBmm30_6_1_b0(M, N, K, alpha, A, lda, rB, ldb, beta, C+1, ldc); 
   ATL_cupMBmm30_6_1_bX(M, N, K, alpha, rA, lda, rB, ldb, ATL_rnone, C, ldc); 
   ATL_cupMBmm30_6_1_b1(M, N, K, alpha, rA, lda, B, ldb, ATL_rone, C+1, ldc); 
}
static void ATL_CupMBmm36_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc)
{
   const float *rA = A + lda*M, *rB = B + ldb*N;
   ATL_cupMBmm36_6_1_b0(M, N, K, alpha, A, lda, B, ldb, ATL_rzero, C, ldc); 
   ATL_cupMBmm36_6_1_b0(M, N, K, alpha, A, lda, rB, ldb, beta, C+1, ldc); 
   ATL_cupMBmm36_6_1_bX(M, N, K, alpha, rA, lda, rB, ldb, ATL_rnone, C, ldc); 
   ATL_cupMBmm36_6_1_b1(M, N, K, alpha, rA, lda, B, ldb, ATL_rone, C+1, ldc); 
}
static void ATL_CupMBmm42_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc)
{
   const float *rA = A + lda*M, *rB = B + ldb*N;
   ATL_cupMBmm42_6_1_b0(M, N, K, alpha, A, lda, B, ldb, ATL_rzero, C, ldc); 
   ATL_cupMBmm42_6_1_b0(M, N, K, alpha, A, lda, rB, ldb, beta, C+1, ldc); 
   ATL_cupMBmm42_6_1_bX(M, N, K, alpha, rA, lda, rB, ldb, ATL_rnone, C, ldc); 
   ATL_cupMBmm42_6_1_b1(M, N, K, alpha, rA, lda, B, ldb, ATL_rone, C+1, ldc); 
}

typedef void (*MMfunc)(const int, const int, const int, const TYPE,
                       const TYPE *, const int, const TYPE *, const int,
                       const TYPE, TYPE *, const int);

void ATL_cpMBmm_b0
   (const int M, const int N, const int K, const TYPE alpha,
    const TYPE *A, const int lda, const TYPE *B, const int ldb,
    const TYPE beta, TYPE *C, const int ldc)
{

   static MMfunc mmfunc[48] = 
   {
      NULL,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_CupMBmm6_6_1_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_CupMBmm12_6_1_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_CupMBmm18_6_1_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_CupMBmm24_6_1_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_CupMBmm30_6_1_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_CupMBmm36_6_1_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_CupMBmm42_6_1_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0,
      ATL_cgpMBmm_b0
   };

   mmfunc[M](M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
}
