#define DREAL
#include "atlas_misc.h"
void ATL_dupMBmm6_6_1_b0
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupMBmm12_6_1_b0
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupMBmm18_6_1_b0
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupMBmm24_6_1_b0
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupMBmm0_4_0_b0
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dgpMBmm_b0
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);

typedef void (*MMfunc)(const int, const int, const int, const TYPE,
                       const TYPE *, const int, const TYPE *, const int,
                       const TYPE, TYPE *, const int);

void ATL_dpMBmm_b0
   (const int M, const int N, const int K, const TYPE alpha,
    const TYPE *A, const int lda, const TYPE *B, const int ldb,
    const TYPE beta, TYPE *C, const int ldc)
{

   static MMfunc mmfunc[30] = 
   {
      NULL,
      ATL_dgpMBmm_b0,
      ATL_dgpMBmm_b0,
      ATL_dgpMBmm_b0,
      ATL_dupMBmm0_4_0_b0,
      ATL_dgpMBmm_b0,
      ATL_dupMBmm6_6_1_b0,
      ATL_dgpMBmm_b0,
      ATL_dupMBmm0_4_0_b0,
      ATL_dgpMBmm_b0,
      ATL_dgpMBmm_b0,
      ATL_dgpMBmm_b0,
      ATL_dupMBmm12_6_1_b0,
      ATL_dgpMBmm_b0,
      ATL_dgpMBmm_b0,
      ATL_dgpMBmm_b0,
      ATL_dupMBmm0_4_0_b0,
      ATL_dgpMBmm_b0,
      ATL_dupMBmm18_6_1_b0,
      ATL_dgpMBmm_b0,
      ATL_dupMBmm0_4_0_b0,
      ATL_dgpMBmm_b0,
      ATL_dgpMBmm_b0,
      ATL_dgpMBmm_b0,
      ATL_dupMBmm24_6_1_b0,
      ATL_dgpMBmm_b0,
      ATL_dgpMBmm_b0,
      ATL_dgpMBmm_b0,
      ATL_dupMBmm0_4_0_b0,
      ATL_dgpMBmm_b0
   };

   mmfunc[M](M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
}
