#define SREAL
#include "atlas_misc.h"
void ATL_supMBmm6_6_1_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_supMBmm12_6_1_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_supMBmm18_6_1_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_sgpMBmm_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);

void ATL_spMBmm_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc)
{

   if (M == (((((M) / 6)) << 2)+((((M) / 6)) << 1)))
   {
      if (M == 18)
      {
         ATL_supMBmm18_6_1_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      }
      else if (M == 12)
      {
         ATL_supMBmm12_6_1_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      }
      else if (M == 6)
      {
         ATL_supMBmm6_6_1_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      }
   }
   else ATL_sgpMBmm_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
}
